Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 867634

Summary: dev-libs/nspr-4.34.1 fails tests (lto): ranfile.c:93:22: error: dereferencing type-punned pointer will break strict-aliasing rules [-Werror=strict-aliasing]
Product: Gentoo Linux Reporter: Agostino Sarubbo <ago>
Component: Current packagesAssignee: Mozilla Gentoo Team <mozilla>
Status: RESOLVED FIXED    
Severity: normal CC: eschwartz, paolo.pedroni
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
See Also: https://bugzilla.mozilla.org/show_bug.cgi?id=439144
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 618550    
Attachments: build.log

Description Agostino Sarubbo gentoo-dev 2022-08-31 05:12:08 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: dev-libs/nspr-4.34.1 fails tests (lto).
Discovered on: amd64 (internal ref: lto_tinderbox)

NOTE:
This machine uses lto with CFLAGS=-flto -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing

Here is a bit of explanation:

-Werror=lto-type-mismatch:
User to find possible runtime issues in packages. It likely means the package is unsafe to build & use with LTO.
For projects using the same identifier but with different types across different files, they must be fixed to be consistent across the codebase.

-Werror=odr:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO. C++ code must comply with the One Definition Rule (ODR) - see https://en.cppreference.com/w/cpp/language/definition#One_Definition_Rule.

-Werror=strict-aliasing:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO.

Workarounds:
- If upstream is friendly and still active, file a bug upstream. For emulators, codecs, games, or multimedia packages, it may be worth just applying a workaround instead, as upstreams sometimes aren't receptive to these bugs (VALID FOR ALL).
- Use the new 'filter-lto' from flag-o-matic.eclass as it's likely to be unsafe with LTO (VALID FOR lto-type-mismatch - odr).
- Fix it yourself if interested, of course (VALID FOR ALL).
- Append-flags -fno-strict-aliasing (VALID FOR strict-aliasing).
- Use memcpy() but a union is sometimes suitable too (VALID FOR strict-aliasing).
- -fstrict-aliasing is implied by -O2, so this must be addressed in some form (VALID FOR strict-aliasing).

See also: https://marc.info/?l=gentoo-dev&m=165639574126280&w=2
Comment 1 Agostino Sarubbo gentoo-dev 2022-08-31 05:12:11 UTC
Created attachment 802090 [details]
build.log

build log and emerge --info
Comment 2 Agostino Sarubbo gentoo-dev 2022-08-31 05:12:13 UTC
Error(s) that match a know pattern in addition to what has been reported in the summary:


   87 |                 printf("PR_Open() failed. Error: %ld, OSError: %ld
   92 |                 printf("PR_Close() failed. Error: %ld, OSError: %ld
  191 |             fprintf(stderr, "First PR_Recv: retVal: %ld, Error: %ld
  201 |             fprintf(stderr, "Second PR_Recv: retVal: %ld, Error: %ld
",
/var/tmp/portage/dev-libs/nspr-4.34.1/work/nspr-4.34.1/nspr/pr/tests/ranfile.c:93:22: error: dereferencing type-punned pointer will break strict-aliasing rules [-Werror=strict-aliasing]
Comment 3 Eli Schwartz gentoo-dev 2024-03-13 06:14:57 UTC
Upstream never formally closed their bug report from 16 years ago in which many such errors existed and people complained that GCC isn't a serious compiler if it complains. Still, it ended up getting mostly fixed.

Mostly. Apparently.
Comment 4 Larry the Git Cow gentoo-dev 2024-03-13 21:04:38 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=9da7e1e40003ff669572d9dd47f11aedd8852f2e

commit 9da7e1e40003ff669572d9dd47f11aedd8852f2e
Author:     Eli Schwartz <eschwartz93@gmail.com>
AuthorDate: 2024-03-13 06:16:54 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2024-03-13 21:04:05 +0000

    dev-libs/nspr: mark as LTO-unsafe, strict-aliasing unsafe
    
    It is a testsuite-only issue. We think, because it prevents, well,
    testing.
    
    Closes: https://bugs.gentoo.org/867634
    Signed-off-by: Eli Schwartz <eschwartz93@gmail.com>
    Signed-off-by: Sam James <sam@gentoo.org>

 dev-libs/nspr/nspr-4.35-r2.ebuild | 8 ++++++++
 1 file changed, 8 insertions(+)